	.386
        .MODEL flat,stdcall

        PUBLIC Fill
        extrn   WadeSpace : PROC, ReadAddress : PROC, ReadNumber : PROC
        extrn   memtop : dword, membase : dword

	.CODE
;
; Fill command
;
Fill    PROC
	call	WadeSpace
	jz	errx
	call	ReadAddress		; read start address
	jc	errx
	call	WadeSpace
	jz	errx
	call	ReadNumber    		; read length
	jc	errx
        cmp     eax,[memtop]
        jae     errx
	mov	ecx,eax
	sub	ecx,ebx
	jc	errx
	call	WadeSpace
        mov     al,0                    ; default Fill = 0
        jz      gotFill
        call    ReadNumber              ; else read a Fill val
	jc	errx
	push	ax
	call	WadeSpace
	pop	ax
	jnz	errx
gotFill:
	mov	edi,ebx
        add     edi,[membase]
	rep	stosb
	clc
	ret
errx:
	stc
	ret
Fill    endp
end