	.386
        .MODEL flat, stdcall

        PUBLIC Move
        extrn ReadAddress : PROC, ReadNumber : PROC,
        extrn WadeSpace : PROC, membase : dword, memtop : dword

	.CODE
;
; move command
;
Move    PROC
	call	WadeSpace
	jz	errx
        call    ReadAddress
	jc	errx
	push	ebx
	call	WadeSpace
	jz	errx2
	call	ReadNumber		; read end of source
	jc	errx2
	mov	ecx,eax
        cmp     eax,[memtop]
        jae     errx2
	sub	ecx,ebx
	jb	errx2
	call	WadeSpace
        jz      errx2
        call    ReadAddress                     ; read dest
	jc	errx2
	call	WadeSpace
	jnz	errx2
        mov     edi,ebx
        pop     esi
        add     edi,[membase]
        add     esi,[membase]
        mov     eax,esi
        add     eax,ecx
        cmp     eax,[memtop]
        jae     errx
        mov     eax,edi
        add     eax,ecx
        cmp     eax,[memtop]
        jae     errx
        cmp     esi,edi
	jz	noop
        jl      sld
sgd:
        cld
	rep	movsb
	jmp	noop
sld:
	lea	esi,[esi+ecx-1]
	lea	edi,[edi+ecx-1]
	std
	rep	movsb
	cld
noop:
	clc				; to clean up stack
	ret
errx2:
	add	sp,8
errx:
	stc
	ret
Move    endp
end