        .386
        .model flat,stdcall
        PUBLIC Math
        extrn   WadeSpace : PROC, PrintDword : PROC, ReadNumber : PROC
        extrn   PrintSpace : PROC,  crlf : PROC
	.CODE
;
; Do math
;
Math  PROC    
	Call	WadeSpace	; Wade till address
	jc	readerr
	call	ReadNumber	; first number
	jc	readerr
	mov	edx,eax
	call	WadeSpace	; get operator
	jz	readerr
	sub	ebx,ebx
	cmp	al,'*'
	jz	got
	inc	bl
	cmp	al,'/'
	jz	got
	inc	bl
	cmp	al,'+'
	jz	got
	inc	bl
	cmp	al,'-'
	jz	got
	inc	bl
	cmp	al,'%'
	jz	got
	dec	si
	mov	bl,5		; default operator = default
got:
        inc     esi
	call	WadeSpace
	jz	readerr
	call	ReadNumber	; second number
	jc	readerr
	mov	ecx,eax
	call	WadeSpace
	jnz	readerr
        shl     bl,2            ; execute operand
	mov	eax,edx
	push	eax
	call	crlf
	pop	eax
        call    [ebx + jumptab]
        call    PrintDword          ; print result
	clc
	ret
jumptab label dword
        dd      xmul,xdiv,xxadd,xsub,xmod,xdefault
xmul:
	mul	ecx
	ret
xmod:
	call	xdiv
	mov	eax,edx
	ret
xdiv:
	or	eax,eax
	jz	nodiv
	sub	edx,edx
	div	ecx
nodiv:
	ret
xxadd:
	add	eax,ecx
	ret
xsub:
	sub	eax,ecx
	ret

xdefault:		; by default act like debug
	push	eax
	push	ecx
	add	eax,ecx
        call    PrintDword
        call    PrintSpace
	pop	ecx
	pop	eax
	sub	eax,ecx
	ret

readerr:
	stc
	ret
Math  ENDP
end