	.386
        .MODEL flat,stdcall


        PUBLIC  Search
        EXTRN   WadeSpace:PROC, ReadNumber : PROC, ReadAddress :PROC
        EXTRN   GetKey : PROC, PrintDword : PROC, membase : dword
        EXTRN   memtop : Dword, crlf : PROC

	.data
PSParglen       dd      0       ;#bytes in GRDBPSP:80h buffer
searchbuf       db      256 dup (0)

	.CODE
Search  PROC
	mov	[PSParglen],0
	call	WadeSpace
	jz	errx
	call	ReadAddress	; read address
	jc	errx
	mov	ecx,ebx
	call	WadeSpace
	jz	errx
	push	ecx
	call	ReadAddress	; read len
	pop	ecx
	jc	errx
        mov     edi,offset searchbuf
grablp:				; read rest of params
	call	WadeSpace
	jz	grabdone
	cmp	al,"'"
	jz	readstring
	cmp	al,'"'
	jnz	readnum
readstring:             	; read a quoted string
        inc     esi
readstringlp:
	lodsb
	cmp	al,13
	jz	grabdone
	cmp	al,'"'
	jz	grablp
	cmp	al,"'"
	jz	grablp
	stosb
	inc	[PSParglen]
        cmp     [PSParglen],256
	jnc	errx
	jmp	readstringlp

readnum:			; read an (8-bit) number
        push    edi
        push    ecx
	call	ReadNumber
        pop     ecx
        pop     edi
	jc	errx2
	stosb
	inc	[PSParglen]
	cmp	[PSParglen],080h
	jnc	errx
	jmp	grablp

grabdone:                       	; all params got now
	test	[PSParglen],0ffh		; see if any search
	jz	errx
        cmp     ebx,[memtop]
        jae     errx
        sub     ebx,ecx
        jc      errx
        call    crlf
        mov     esi,ecx
        add     esi,[membase]
noseg:
        call    GetKey         ; I put this in for debug, but,
        or      eax,eax
        jnz     nofill2         ; good for mistakes too...
        mov     ecx,[PSParglen]
	push	esi
        mov     edi,offset searchbuf
	repe	cmpsb
	pop	esi
	jnz	nomatch
	push	ebx
	mov	eax,esi
        sub     eax,[membase]
        call    PrintDword
	call	crlf
	pop	ebx
nomatch:
	inc	esi
	dec	ebx
	jne	noseg
	clc
	ret
nofill:
nofill2:
	clc
	ret
errx2:
errx:
	stc
	ret
Search  endp
end