        .486
        .model flat,stdcall

include opcode.inc

        public  trace,proceed,go, ISRCallBack,run
        extrn  Dregs: dword, Aregs : dword, SR : dword, PC: dword, USP:dword
        extrn   membase : dword, WadeSpace : PROC, ReadNumber : PROC
        extrn   DisplayRegisters : PROC, GetKey : PROC
        extrn   filloneline : PROC, ExecuteInstruction : PROC, left : dword
        extrn   firstword : dword, CheckBreak : PROC, debug:byte

        .data

inscount        dd      0

        .code
ISRCallBack PROC
        ret
ISRCallBack ENDP
breakaddr PROC
        mov     esi,[PC]
        add     esi,[membase]
        call    filloneline
        mov     al,[ebx + opcode.exect]
        cmp     al,I_JSR
        jz      breakok
        cmp     al,I_DBX
        jz      breakok
        cmp     al,I_TRAP
        jz      breakok
        cmp     al,I_TRAPX
        jz      breakok
        cmp     al,I_TRAPV
        jz      breakok
        cmp     al,I_CALLM
        jz      breakok
        cmp     al,I_ILLEGAL
        jz      breakok
        cmp     al,I_BRANCH
        jnz     breakno
        mov     eax,[firstword]
        cmp     ah,61h
        jz      breakok
breakno:               
        stc
        ret
breakok:
        mov     eax,esi
        sub     eax,[membase]
        clc
        ret
breakaddr ENDP

broken PROC
        inc     [inscount]
        test    [inscount],0fffffh
        jnz     notest
        call    GetKey
        or      eax,eax
        jz      notest
        cmp     al,3
        stc
        jz      notest
        clc
notest:
        ret
broken ENDP
trace PROC
        mov     ecx,1           
        call    WadeSpace
        jz      tracecont
        call    ReadNumber
        jc      tracex
        mov     ecx,eax
tracecont:
        mov     esi,[PC]
        add     esi,[membase]
trlp:
        push    ecx
        call    ExecuteInstruction
        pop     ecx
        jc      trok
        call    broken
        jc      trok
        loop    trlp
trok:
        sub     esi,[membase]
        mov     [PC],esi
        call    DisplayRegisters
        mov     [left],0
        clc
tracex:
        ret
trace ENDP
proceed PROC
        call    breakaddr
        mov     ecx,1
        jc      tracecont
gocont:
        add     eax,[membase]
        push    eax
        mov     esi,[PC]
        add     esi,[membase]
plp:
        call    ExecuteInstruction
        jc      px
        call    broken
        jc      px
        mov     eax,esi
        call    CheckBreak
        jz      px
        cmp     esi,[esp]
        jnz     plp
px:
        pop     eax
        sub     esi,[membase]
        mov     [PC],esi
        test    [debug],1
        jz      noregs
        call    DisplayRegisters
        mov     [left],0
noregs:
        clc
        ret
proceed ENDP
run proc
        mov     eax,-1
        jmp     gocont
run endp
go proc
        call    WadeSpace
        mov     eax,-1
        jz      gocont
        call    ReadNumber
        jc      goerr
        jmp     gocont
goerr:
go endp
        end